package mod.mcreator;

import net.minecraft.world.storage.WorldSavedData;
import net.minecraft.world.World;
import net.minecraft.nbt.NBTTagCompound;

public class mcreator_VarListadvanced_redstone {

	public static class MapVariables extends WorldSavedData {

		private static final String DATA_NAME = "advanced_redstone_mapvars";
		public double emitterActivate = 0;
		public double emitterDeactivate = 0;
		public double emitter_id = 0;
		public double pairLevel = 0;

		public MapVariables() {
			super(DATA_NAME);
		}

		public MapVariables(String s) {
			super(s);
		}

		@Override
		public void readFromNBT(NBTTagCompound nbt) {
			emitterActivate = nbt.getDouble("emitterActivate");
			emitterDeactivate = nbt.getDouble("emitterDeactivate");
			emitter_id = nbt.getDouble("emitter_id");
			pairLevel = nbt.getDouble("pairLevel");
		}

		@Override
		public NBTTagCompound writeToNBT(NBTTagCompound nbt) {
			nbt.setDouble("emitterActivate", emitterActivate);
			nbt.setDouble("emitterDeactivate", emitterDeactivate);
			nbt.setDouble("emitter_id", emitter_id);
			nbt.setDouble("pairLevel", pairLevel);
			return nbt;
		}

		public static MapVariables get(World world) {
			MapVariables instance = (MapVariables) world.getMapStorage().getOrLoadData(MapVariables.class, DATA_NAME);
			if (instance == null) {
				instance = new MapVariables();
				world.getMapStorage().setData(DATA_NAME, instance);
			}
			return instance;
		}
	}

	public static class WorldVariables extends WorldSavedData {

		private static final String DATA_NAME = "advanced_redstone_worldvars";

		public WorldVariables() {
			super(DATA_NAME);
		}

		public WorldVariables(String s) {
			super(s);
		}

		@Override
		public void readFromNBT(NBTTagCompound nbt) {
		}

		@Override
		public NBTTagCompound writeToNBT(NBTTagCompound nbt) {
			return nbt;
		}

		public static WorldVariables get(World world) {
			WorldVariables instance = (WorldVariables) world.getMapStorage().getOrLoadData(WorldVariables.class, DATA_NAME);
			if (instance == null) {
				instance = new WorldVariables();
				world.getMapStorage().setData(DATA_NAME, instance);
			}
			return instance;
		}
	}
}
